<year-input>
<div id="{divid}">
	<img id="{bid}" src='images/ymprev.png' onclick={backcal} style='vertical-align: middle;'></img>
	<input type="text" id="{id}" name="{id}" maxlength="{maxlength}" style="{style}" class="{css}" onchange={checkcal} value="{value}" placeholder="{placeholder}"/>{label}
	<img id="{nid}" src='images/ymnext.png' onclick={nextcal} style='vertical-align: middle;'></img>
<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
</div>
<script>
	this.id = opts.tagid;
	this.divid = opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.maxlength = opts.maxlength ? opts.maxlength : '4';
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled; ' + (opts.style ? opts.style : 'width:43px;');
	this.label = opts.label;
	this.msgstyle = opts.msgstyle;
	this.placeholder = (opts.placeholder) ? opts.placeholder : 'yyyy';
	
	this.bid = this.id + 'Back';
	this.nid = this.id + 'Next';
	this.minyear = opts.minyear ? opts.minyear : '1900';
	this.maxyear = opts.maxyear ? opts.maxyear : '2999';
		
	this.regptn = /[^0-9]+/;

	backcal(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		if ($('#' + this.id).val().length < 1) {
			var sysyear = valueToYm(Date.now()).substr(0,4);
			$('#' + this.id).val(sysyear);
			return;
		}
		var rtn = this.checkcal(); 
		if (rtn) {
			this.calccal(-1);
		} else {
			console.log('err004:' + $(this.messageid));
		}
	}
	
	nextcal(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		if ($('#' + this.id).val().length < 1) {
			var sysyear = valueToYm(Date.now()).substr(0,4);
			$('#' + this.id).val(sysyear);
			return;
		}
		var rtn = this.checkcal(); 
		if (rtn) {
			this.calccal(1);
		} else {
			console.log('err004:' + $(this.messageid));
		}
	}
	
	calccal(num) {
		var dt = new Date();
		dt.setFullYear($('#' + this.id).val());
		dt.setFullYear(dt.getFullYear() + num);
		$('#' + this.id).val(dt.getFullYear());
	}
	
	checkcal() {
		if ($('#' + this.id).val().length > this.maxlength) {
			console.log('err001:' + $(this.messageid));
			return false;
		}
		if($('#' + this.id).val().match(this.regptn)) {
			console.log('err002:' + $(this.messageid));
			return false;
		}

		if($('#' + this.id).val() <= this.minyear
				|| $('#' + this.id).val() >= this.maxyear) {
			console.log('err003:' + $(this.messageid));
			return false;	
		}
		return true;
	}

	/**
	 * マウント時の処理
	 */
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id).attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
	
</script>
</year-input>
